#sccs	"@(#)adminbin:Install.sh	1.18"


# ----------------------------------------------------------------------
#                                                             Install.sh
# PURPOSE:  Install application software
# CALLED BY: Software Setup object in Admin-kit
# REQUIRED FILES: /etc/iv,
# ----------------------------------------------------------------------

CONTENTS=/usr/installed/CONTENTS
INDIR=/usr/installed
TERMCAP=
export TERMCAP

# Lower and Upper bound for the number of diskettes to be installed
LOW=1		
HIGH=99999

# Trap the delete key
trap "rm -rf /tmp/SAVE$$" 2

rm -rf /tmp/installed
umask 022
mkdir /tmp/installed
cd /tmp/installed

SAVELIBS=true
while true
do
	if [ "$SAVELIBS" = "false" ]
	then	clear
	fi
	message -cu "To install programs from floppy disks,\nyou must insert them one by one,\nas you are prompted, in order.\n\nPlease insert the first floppy.\n"
	if [ $? != "0" ]
	then
		exit
	fi

	while true
	do
		clear
		newwind
		if [ -r Size ]
		then
			rm -f Size
		fi
		echo "\n\n                     Checking for Size file.\n\n"
		cpio  -icBuK Size < /dev/rfp021 2>&1 >/dev/null
		err=$?
		if [ $err != "0" ] 
		then
			clear
			message -cu "An error was encountered while reading in the floppy disk.\nPlease be sure to insert them properly. If this problem reoccurs at the same floppy, the disk may be bad."
			exit
		fi

		if [ -r Size ]
		then
			NUMBER=`cat Size`
			break
		else
 			#
            		# repeat the loop for number of diskettes until a
			# valid entry is made
			#
 			NUMERIC=0
                        while [ "$NUMERIC" != "1" ]
                        do
                 		NUMERIC=1
            			clear
	        		RET=`shform -u $UA/Installn.form`

	        		if [ "$?" != "0" ]
	         		then
		        		message $ERROR1
		        		exit
        			fi
         			clear
         			eval set $RET

	         		if [ "$1" = "Cancel" ]
         			then 
	         			cd /tmp
		        		rm -rf /tmp/installed /tmp/cplog$$
		        		exit
         			fi

	         		if [ "$1" = "Help" ]
         			then
	           			/usr/bin/uahelp -h /usr/lib/ua/admin.hlp -t "Install Software"
					NUMERIC=0
           			elif [ "$1" = "Enter" ]
	         		then
                 			clear
                 			# KEY is the number of diskettes entered   
                                        KEY=$2
                          		if [ \( `expr $KEY \< $LOW` = "1" \) -o \( `expr $KEY \> $HIGH` = "1" \) ]
                             		then
		                    		message -ui "Invalid entry! Please type in the number of diskettes to be installed again.\n\nPlease hit ENTER to continue."
                    				NUMERIC=0
	                    		else
                           			NUMBER=`expr ${2}00 \* 6 `
	                           		break
                  			fi
	             		fi
               		done
	   	fi
		if [ "NUMERIC" != "0" ]
			then break
			fi
	done

	# WARNING:
	#   The following programs may be overwritten by some foreign
	#   install program.  To prevent this, each must be saved and
	#   then restored.  The restore portion is at the end of this
	#   program.  Change both or neither.

	if $SAVELIBS
	then
		SAVELIBS=false
		mkdir /tmp/SAVE$$
		cpio -pud /tmp/SAVE$$ << -END- 2> /dev/null
/bin/ld
/lib/crt0.o
/lib/ifile.0413
/lib/libc.a
/lib/libm.a
/usr/lib/libmath.a
-END-
	fi

	set `df -t /`
	FREE=$3
	if [  `expr $NUMBER \> $FREE` = "1" ] 
	then
		clear
		message -iu "There is not enough room on the system to install the package.  Please remove some files and try again.\n\nPress Enter to continue."
		break
	fi

	FLOP=`iv -t /dev/rfp020 2>/dev/null | grep Partition`
	if [ "$?" != "0" ]
	then
		dismount -f > /dev/null 2>&1
		clear
		message -cu "Either the floppy disk is not inserted correctly, the disk has an error, or the door is not closed.  Please check the floppy disk.\n"
		if [ $? != "0" ]
		then break
		fi
	else
		clear
		newwind
		echo "\n\n                         Install in progress\n\n\n"
		cpio  -icBdu < /dev/rfp021 2>/tmp/cplog$$
		err=$?
		if [ "`grep \"Out of phase\" /tmp/cplog$$`" ]
		then
			clear
			message -cu "The floppy diskette you inserted is either not the correct floppy, or you inserted it in the wrong order.  Please re-insert the first floppy diskette and start over.  If this problem reoccurs at the same floppy, the disk may be bad."
			if [ $? != "0" ]
			then break
			fi
		elif [ "`grep \"annot create\" /tmp/cplog$$`" ]
		then
			clear
			message -u "Your system is out of space.  Please remove some files and try again."
			break
		elif [ "$err" != "0" ] 
		then
			clear
			message -cu "An error was encountered while reading in the floppy disk(s).\nPlease be sure to insert them in the proper order,\nand wait for the notification before removing them.  If this problem reoccurs at the same floppy, the disk may be bad."
			if [ $? != "0" ]
			then break
			fi
		elif [ -f ./Install ]
		then
			if [ -f "Name" ]
			then
				NAME=`cat -s Name`
				FNAME=`date '+%y%m%d' `$$
				if [ -r ./Remove ]
				then 
					clear
					chmod +x ./Install
					./Install
					if [ "$?" = "64" ]
						then break
					fi

					echo $FNAME $NAME >> $CONTENTS
					mv ./Remove ${INDIR}/${FNAME}.un
				#  add item to Uninstall.menu 
					if [ ! "`grep Name=$NAME $UA/Uninstall.menu>/dev/null 2>&1`" ]
					then 
						echo "Name="$NAME >>$UA/Uninstall.menu
						echo "Name="$NAME >>$UA/Showsoft.menu
					fi
					I=`ps -e | grep ua | cut -c1-6`
					for i in $I
					do
						kill -16 $i
					done
					clear
					message -iu "The installation of the $NAME package is now complete.\n\nPlease press Enter to continue."
					break
				else
					clear
					message -cu "The install floppy is missing the 'Remove' program.\nPlease check to make sure you have the right floppy."
					if [ $? != "0" ]
					then break
					fi
				fi
			else
				clear
				message -cu "The install floppy is missing the 'Name' program.\nPlease check to make sure you have the right floppy."
				if [ $? != "0" ]
				then break
				fi
			fi
		else
			clear
			message -cu "The install floppy is missing the 'Install' program.\nPlease check to make sure you have the right floppy."
			if [ $? != "0" ]
			then break
			fi
		fi
	fi
clear
done
cd /tmp
rm -rf /tmp/installed /tmp/cplog$$


##  PROTECT UPDATED VERSIONS OF THE SOFTWARE

while read FILE CHKSUM
do
	if [ ! "$FILE" ]
	then	continue
	fi

	if expr "$FILE" : "#" > /dev/null 2>&1
	then	continue
	fi

	if [ -s "$FILE" ]
	then
		CURSUM=`sum $FILE | cut -f1 -d' '`
		if [ "$CURSUM" = "$CHKSUM" ]
		then
			GOODFILE="/etc/fixes/`basename $FILE`"
			cp $GOODFILE $FILE
			echo "$FILE updated on `date`" >> /etc/.fixedfiles
		fi
	fi
done < /etc/fixes/.fixedlist

# WARNING:
#   The following programs may have been overwritten by some foreign
#   install program.  To cure this, each must be restored.

expr "$NAME" : ".*[Dd][Ee][Vv][Ee][Ll][Oo][Pp]" > /dev/null
fDEVSET=$?

if [ $fDEVSET != 0 ]
then
	cd /tmp/SAVE$$
	cpio -pud / << -END- 2> /dev/null
./bin/ld
./lib/crt0.o
./lib/ifile.0413
./lib/libc.a
./lib/libm.a
./usr/lib/libmath.a
-END-
	cd ..
	rm -rf /tmp/SAVE$$
fi

rm -rf /tmp/SAVE$$
# -----------------------------------------------------------------------
#  EXECUTABLE PROGRAM ENDS HERE                                Install.sh
# =======================================================================
