#sccs	"@(#)phone:phPhones.sh	1.1"

#                                                                 Phones.sh
# PURPOSE: Control of /etc/.lineone and /etc/.linetwo
# CALLED BY: Admin-kit
# REQUIRED FILES: Phones.form
# MODIFIED FILES: /etc/.lineone, /etc/.linetwo
# -------------------------------------------------------------------------

ERROR1="An error has been encountered in the form file Phones.form\n  Please notify AT&T User Support.  Thank you."
ERROR2="The command provided was not recognized.\nPlease use Enter or Cancl."
ERROR3="Telephone line 2 must be the second line - it cannot be set up if there is no telephone line 1.\nTHE SETUP HAS NOT BEEN CHANGED!"
ERROR4="Telephone line $LINE is in use.  Try again later."

NOLINE1=0
NOLINE2=0
NOCHANGE=0
TERMCAP=
export TERMCAP
umask 022

LFDIR=/usr/lib/uucp

LINE="1"
if [ -f $LFDIR/LCK..ph0 ]
then
	message "$ERROR4"
	exit
fi

LINE="2"
if [ -f $LFDIR/LCK..ph1 ]
then
	message "$ERROR4"
	exit
fi

# Get the information from /etc files

if [ -s /etc/.lineone ]
then
	. /etc/.lineone
	L1="YES"
else
	L1="NO"
	TT1="YES"
	KS1="NO"
	MS1="NO"
fi

if [ -s /etc/.linetwo ]
then
	. /etc/.linetwo
	L2="YES"
else
	L2="NO"
	MD2="DATA"
	TT2="YES"
	KS2="NO"
fi
export L1 TT1 KS1 L2 MD2 TT2 KS2 MS1

# Execute the telephone form

while true
do
RET=`shform -u $UA/Phones.form`
if [ "$?" != "0" ]
then
	message "$ERROR1"
	exit
fi
eval set $RET
PID=`cat $UA/phpid`


case $1 in
	Enter)
		shift 1
  
                # test the entries for LINE1 and LINE2

		if [ \( "$1" = "NO" \) -o \( "$1" = "no" \) -o \( "$1" = "No" \) -o \( -z "$1" \) ]
		then
                        NOLINE1=1
                fi

                if [ \( "$5" = "NO" \) -o \( "$5" = "no" \) -o \( "$5" = "No" \) -o \( -z "$1" \) ]
                then 
                        NOLINE2=1
                fi

                # update the files if necessary

                if [ \( "$NOLINE1" = "1" \) -a \( "$NOLINE2" != "1" \) ]
                then  
                        message $ERROR3
                        NOCHANGE=1
                else
                        if [ "$NOLINE1" = "1" ]
                        then

	                       	rm -f /etc/.lineone
			        getoff.sh ph0
	         	else
		        	cat > /etc/.lineone <<END
MD1=VOICE
TT1=$2
KS1=$3
MS1=$4
END
	        	fi

		        shift 4
                        if [ "$NOLINE2" = "1" ]
                        then
			        rm -f /etc/.linetwo
                                if [ "$NOLINE1" != "1" ]
                                then
			         	grep -v "OBM ph" /usr/lib/uucp/L-devices >/tmp/L-dev$$
	            			echo "OBM ph0 UNIXPC 1200" >> /tmp/L-dev$$ 
		        		mv /tmp/L-dev$$ /usr/lib/uucp/L-devices
	          			sed < /usr/lib/uucp/L.sys "s/ph1/ph0/p" > /tmp/L.sys$$
	         			mv /tmp/L.sys$$ /usr/lib/uucp/L.sys
	        		fi
	        	else
	         		cat > /etc/.linetwo <<END
MD2=$2
TT2=$3
KS2=$4
END
	         		grep -v "OBM ph" /usr/lib/uucp/L-devices >/tmp/L-dev$$
	        		echo "OBM ph1 UNIXPC 1200" >> /tmp/L-dev$$ 
		        	mv /tmp/L-dev$$ /usr/lib/uucp/L-devices
	         		sed < /usr/lib/uucp/L.sys "s/ph0/ph1/p" > /tmp/L.sys$$
	         		mv /tmp/L.sys$$ /usr/lib/uucp/L.sys
	        	fi
                fi
               
		# Kill the old process if there is a new phone setup.
		# Or else, reset the flags and show the form again.
                if [ "$NOCHANGE" != "1" ]
		then
         		echo "Admin" > $UA/phnum
         		kill -17 $PID
			grep "root::" /etc/passwd > /dev/null 2>&1
			if [ "$?" = "0" ]
			then
				message -c "UNIX provides for a non-office login called \"root\".  You should provide a password for this login in order to prevent unauthorized access via the phone lines.  Touch Enter to provide a root password now, or Cancel to skip."
				if [ "$?" = "0" ]
				then
					password root 1
				fi
			fi
       		   	break
 		else
			NOLINE1=0
			NOLINE2=0
             	fi
	;;

# This is the Exit code if command is cancelled
	Cancel)
		exit
	;;

# help screen
	Help)
		/usr/bin/uahelp -h $UA/admin.hlp -t "Phone Setup"
		NOCHANGE=1
	;;

# Unrecognizable return from action key
	*)
		message "$ERROR2"
		NOCHANGE=1
	;;

esac

clear

if [ "$NOCHANGE" != "1" ]
then
	grep "root::" /etc/passwd > /dev/null 2>&1
	if [ "$?" = "0" ]
	then
		message -c "UNIX provides for a non-office login called \"root\".  You should provide a password for this login in order to prevent unauthorized access via the phone lines.  Touch Enter to provide a root password now, or Cancel to skip."
		if [ "$?" = "0" ]
		then
			password root 1
		fi
	fi
else
	NOCHANGE=0
fi

done

# -------------------------------------------------------------------------
#  EXECUTABLE PROGRAM ENDS HERE                                  Phones.sh
# =========================================================================
