#sccs	"@(#)uts/kern/sys:errno.h	1.4"

/*	Convergent Technologies - System V - May 1983	*/

/*
 * Error codes
 */

#define	EPERM	1	/* Not super-user			*/
#define	ENOENT	2	/* No such file or directory		*/
#define	ESRCH	3	/* No such process			*/
#define	EINTR	4	/* interrupted system call		*/
#define	EIO	5	/* I/O error				*/
#define	ENXIO	6	/* No such device or address		*/
#define	E2BIG	7	/* Arg list too long			*/
#define	ENOEXEC	8	/* Exec format error			*/
#define	EBADF	9	/* Bad file number			*/
#define	ECHILD	10	/* No children				*/
#define	EAGAIN	11	/* No more processes			*/
#define	ENOMEM	12	/* Not enough core			*/
#define	EACCES	13	/* Permission denied			*/
#define	EFAULT	14	/* Bad address				*/
#define	ENOTBLK	15	/* Block device required		*/
#define	EBUSY	16	/* Mount device busy			*/
#define	EEXIST	17	/* File exists				*/
#define	EXDEV	18	/* Cross-device link			*/
#define	ENODEV	19	/* No such device			*/
#define	ENOTDIR	20	/* Not a directory			*/
#define	EISDIR	21	/* Is a directory			*/
#define	EINVAL	22	/* Invalid argument			*/
#define	ENFILE	23	/* File table overflow			*/
#define	EMFILE	24	/* Too many open files			*/
#define	ENOTTY	25	/* Not a typewriter			*/
#define	ETXTBSY	26	/* Text file busy			*/
#define	EFBIG	27	/* File too large			*/
#define	ENOSPC	28	/* No space left on device		*/
#define	ESPIPE	29	/* Illegal seek				*/
#define	EROFS	30	/* Read only file system		*/
#define	EMLINK	31	/* Too many links			*/
#define	EPIPE	32	/* Broken pipe				*/
#define	EDOM	33	/* Math arg out of domain of func	*/
#define	ERANGE	34	/* Math result not representable	*/
#define	ENOMSG	35	/* No message of desired type		*/
#define	EIDRM	36	/* Identifier removed			*/
#define	ECHRNG	37	/* Channel number out of range		*/
#define	EL2NSYNC 38	/* Level 2 not synchronized		*/
#define	EL3HLT	39	/* Level 3 halted			*/
#define	EL3RST	40	/* Level 3 reset			*/
#define	ELNRNG	41	/* Link number out of range		*/
#define	EUNATCH 42	/* Protocol driver not attached		*/
#define	ENOCSI	43	/* No CSI structure available		*/
#define	EL2HLT	44	/* Level 2 halted			*/

/* Convergent Error Returns */
#define EBADE	50	/* invalid exchange			*/
#define EBADR	51	/* invalid request descriptor		*/
#define EXFULL	52	/* exchange full			*/
#define ENOANO	53	/* no anode				*/
#define EBADRQC	54	/* invalid request code			*/
#define EBADSLT	55	/* invalid slot				*/
#define EDEADLOCK 56	/* file locking deadlock error		*/

#define EBFONT	57	/* bad font file fmt			*/

#ifndef BASSLOCKING
#define ENOLCK 58	/* no more locks available		*/
#define EDEADLK 59	/* file locking deadlock error		*/
#endif

/* stream problems */
#define ENOSTR	60	/* Device not a stream			*/
#define ENODATA	61	/* no data (for no delay io)		*/
#define ETIME	62	/* timer expired			*/
#define ENOSR	63	/* out of streams resources		*/

#define ENONET	64	/* Machine is not on the network	*/
#define ERSYS	65	/* Inode is remote (not really error)	*/
#define EREMOTE	66	/* The object is remote			*/
#define ENOLINK	67	/* the link has been severed */
#define EADV	68	/* advertise error */
#define ESRMNT	69	/* srmount error */

#define	ECOMM	70	/* Communication error on send		*/
#define EPROTO	71	/* Protocol error			*/
#define	ECROSSMNT 72	/* Cross mount point (not really error)	*/
#define	ENONS	73	/* Name server not running at port	*/
#define	EMULTIHOP 74	/* multihop attempted */
#define	DU_LBIN	75	/* Inode is remote (not really error)*/
#define	DU_DOTDOT 76	/* Cross mount point (not really error)*/
#define EBADMSG 77	/* trying to read unreadable message	*/

#define ENOTUNIQ	80		/* given log. name not unique */
#define EBADFD		81		/* f.d. invalid for this operation */
#define EREMCHG		82		/* Remote address changed */


#define ENOHDW	224	/* No hardware available for operation */
#define EBADFS	225	/* bitmapped filesystem is marked dirty */

/* Errors from 4.2 BSD picked up to support sockets */
/* Note that the numbers are different from 4.2 numbering */

/* non-blocking and interrupt i/o */
#define	EWOULDBLOCK	226		/* Operation would block */
#define	EINPROGRESS	227		/* Operation now in progress */
#define	EALREADY	228		/* Operation already in progress */
/* ipc/network software */

	/* argument errors */
#define	ENOTSOCK	229		/* Socket operation on non-socket */
#define	EDESTADDRREQ	230		/* Destination address required */
#define	EMSGSIZE	231		/* Message too long */
#define	EPROTOTYPE	232		/* Protocol wrong type for socket */
#define	EPROTONOSUPPORT	233		/* Protocol not supported */
#define	ESOCKTNOSUPPORT	234		/* Socket type not supported */
#define	EOPNOTSUPP	235		/* Operation not supported on socket */
#define	EPFNOSUPPORT	236		/* Protocol family not supported */
#define	EAFNOSUPPORT	237		/* Address family not supported by protocol family */
#define	EADDRINUSE	238		/* Address already in use */
#define	EADDRNOTAVAIL	239		/* Can't assign requested address */

	/* operational errors */
#define	ENETDOWN	240		/* Network is down */
#define	ENETUNREACH	241		/* Network is unreachable */
#define	ENETRESET	242		/* Network dropped connection on reset */
#define	ECONNABORTED	243		/* Software caused connection abort */
#define	ECONNRESET	244		/* Connection reset by peer */
#define	ENOBUFS		245		/* No buffer space available */
#define	EISCONN		246		/* Socket is already connected */
#define	ENOTCONN	247		/* Socket is not connected */
#define	ESHUTDOWN	248		/* Can't send after socket shutdown */
#define	ETOOMANYREFS	249		/* Too many references: can't splice */
#define	ETIMEDOUT	250		/* Connection timed out */
#define	ECONNREFUSED	251		/* Connection refused */


/* should be rearranged */
#define	EHOSTDOWN	252		/* Host is down */
#define	EHOSTUNREACH	253		/* No route to host */
#define	ENOPROTOOPT	254		/* Protocol not available */
/* avoid 255 (it's a -1 for a char ) */
